<style>
.team-img {
  border-radius: 50%;
}
.vertical-alt {
  margin: 0;
  position: absolute;
  top: 50%;
  left: 50%;
  -ms-transform: translate(-50%, -50%);
  transform: translate(-50%, -50%);
}
.limit{
  margin-top: 0.5rem;
  word-break: break-all;
}
</style>
<template>
  <main>
    <div class="section">
      <div class="">
        <scroll-load
          key='user-row'
          class='columns is-multiline'
          v-if='users.length'
          :loading='loading'
          @loadNext='fetchData'
        >
          <div class="column is-4" v-for='user in users' :key='"user-row" + user.username' v-show="user"><div class="card">
            <div class="card-content">
              <router-link :to="'/u/' + user.username"><b-button style="float:right;">View</b-button></router-link>
              <div class="media">
                <div class="media-left">
                  <figure class="image is-64x64">
                    <avatar-icon :user="user" size="small"></avatar-icon>
                  </figure>
                </div>
                <div class="media-content">
                  <p class="title is-4">{{user.username}}</p>
                  <p class="subtitle is-6">{{user.postCount}} Posts</p>
                </div>
              </div>

              <div class="content limit">
                {{user.description}}
              </div>
            </div>
          </div>
          </div>
        </scroll-load>
      </div>
    </div>
    <p name='fade' mode='out-in'>
    <center><loading-message key='loading' v-if='loading'></loading-message></center>
    <center><div class='overlay_message' v-if='!loading && !users.length'>
      Something went wrong while loading the users, check your internet connection, or check the <a href="https://status.troplo.com">Service Status</a>
    </div></center></p>
  </main>
</template>
<script>
import LoadingMessage from '../LoadingMessage';
import ScrollLoad from '../ScrollLoad';
import throttle from 'lodash.throttle';
import AjaxErrorHandler from '../../assets/js/errorHandler';
import AvatarIcon from '../AvatarIcon';

export default {
  name: 'UserList',
  components: {
    LoadingMessage,
    ScrollLoad,
    AvatarIcon
  },
  data () {
    return {
      search: '',
      users: [],

      loading: true,
      offset: 0,
      limit: 15,
      showTeamTab: 0,
      createTeamModal: false,
      tcreateProd: {
        username: '',
        name: '',

        loading: false,

        errors: {
          username: '',
          name: ''
        }
      },

      roleOptions: [
        { name: 'Admins', value: 'admin' },
        { name: 'Users', value: 'user' }
      ],
      roleSelected: ['admin', 'user'],

      tableSort: {
        column: 'username',
        sort: 'desc'
      }
    }
  },
  methods: {
    clearTeamErrors() {
      this.tcreateProd.errors.username = ''
      this.tcreateProd.errors.name = ''
    },
    closeAccountModal() {
      this.createTeamModal = false
    },
    createTeam() {
      let postParams = {
        username: this.tcreateProd.username,
        name: this.tcreateProd.name
      }
      this.tcreateProd.loading = true

      this.axios.post(process.env.VUE_APP_APIENDPOINT + process.env.VUE_APP_APIVERSION + `/` + `teams/create`, postParams).then(res => {
        this.signup.loading = false
        this.$store.commit('setUsername', res.data.username)
        this.closeAccountModal()
      }).catch(e => {
        this.tcreateProd.loading = false
        AjaxErrorHandler(this.$store)(e);
      })
    },
    fetchData () {
      if(this.offset === null) return;

      let url = process.env.VUE_APP_APIENDPOINT + process.env.VUE_APP_APIVERSION + `/` + `user?
					sort=${this.tableSort.column}
					&order=${this.tableSort.sort}
					&offset=${this.offset}
				`;
      if(this.roleSelected.length === 1) {
        url += '&role=' + this.roleSelected[0];
      }
      if(this.search.length) {
        url += '&search=' + encodeURIComponent(this.search.trim());
      }

      this.loading = true;
      this.axios
        .get(url)
        .then(res => {
          this.users.push(...res.data);
          this.loading = /*loading =*/ false;

          //If returned data is less than the limit
          //then there must be no more pages to paginate
          if(res.data.length < this.limit) {
            this.offset = null;
          } else {
            this.offset+= this.limit;
          }
        })
        .catch(e => {
          AjaxErrorHandler(this.$store)(e);
          this.loading = /*loading =*/ false;
        });
    },
    resetFetchData () {
      this.offset = 0;
      this.users = [];

      this.fetchData();
    }
  },
  getNewerUsers () {
    this.loadingNewer = true

    this.axios
      .get(process.env.VUE_APP_APIENDPOINT + process.env.VUE_APP_APIVERSION + '/' + 'user' + '?limit=' + this.newUsers)
      .then(res => {
        this.loadingNewer = false
        this.newUsers = 0

        this.threads.unshift(...res.data.Threads)
      })
      .catch((e) => {
        this.loadingNewer = false
        AjaxErrorHandler(this.$store)(e)
      })
  },
  mounted () {
    this.fetchData();
  },
  watch: {
    tableSort: 'resetFetchData',
    roleSelected: 'resetFetchData',
    search: throttle(function () {
      this.resetFetchData();
    }, 200)
  }
}
</script>
